extends KinematicBody2D

var speed : Vector2
var velocity : Vector2
var GO_LEFT : Vector2
var GO_RIGHT : Vector2
var DOWN : Vector2
var JUMP : Vector2

var can_catch: bool
var holding_shell: bool
var looking_left: bool
var overlapping_shell: bool
var throwing_shell: bool

onready var node_shell = get_node("/root/Node2D/Shell")
onready var node_mario = get_node("/root/Node2D/Mario")

func _ready():
	speed = Vector2(200,200)
	velocity = Vector2(0,0)
	GO_LEFT = Vector2(-200,0)
	GO_RIGHT= Vector2(200,0)
	JUMP=Vector2(0,-1000)
	DOWN=Vector2(0,30)
	throwing_shell=false


func get_input():
	$AnimatedSprite.position=Vector2(0,0)
	if (is_on_floor() and get_floor_normal() != Vector2(0,-1)):
		$AnimatedSprite.position=Vector2(0,3)
	if (not(Input.is_action_pressed("ui_right")) and
	not(Input.is_action_pressed("ui_left"))):
		animate_hold()
		if is_on_floor():
			velocity=Vector2(0,0)
	if Input.is_action_pressed("ui_right"):
		velocity = velocity + GO_RIGHT
		animate_walk_right()
	if Input.is_action_pressed("ui_left"):
		velocity = velocity + GO_LEFT
		animate_walk_left()
	if Input.is_action_pressed("ui_down") and is_on_floor():
		$AnimatedSprite.animation="Down"
	velocity=velocity+DOWN
	if Input.is_action_pressed("ui_up") and is_on_floor():
		velocity=velocity+JUMP
	if Input.is_action_just_pressed("Catch"):
		if can_catch==true:
			holding_shell=true
	if Input.is_action_just_pressed("Throw"):
		throwing_shell=true



func set_animation():
	if not(is_on_floor()):
		if velocity.y > 0:
			$AnimatedSprite.animation="Fall"
		if velocity.y < 0:
			$AnimatedSprite.animation="Jump"

func animate_hold():
	if  holding_shell == true:
		$AnimatedSprite.animation="Stand-Hold"
	else:
		$AnimatedSprite.animation="Stand"
		
func animate_walk_left():
	$AnimatedSprite.flip_h=false
	looking_left=true
	if holding_shell==true:
		$AnimatedSprite.animation="Walk-Hold"
	else:
		$AnimatedSprite.animation="Walk"

func animate_walk_right():
	$AnimatedSprite.flip_h=true
	looking_left=false
	if holding_shell==true:
		$AnimatedSprite.animation="Walk-Hold"
	else:
		$AnimatedSprite.animation="Walk"

func _on_RightCatch_body_entered(_body):
	if node_shell.koopa_is_shell==true:
		can_catch = true

func _on_LeftCatch_body_entered(_body):
	if node_shell.koopa_is_shell==true:
		can_catch = true

func _on_RightCatch_body_exited(_body):
	can_catch = false

func _on_LeftCatch_body_exited(_body):
	can_catch = false

func _on_Area2D_body_entered(_body):
	overlapping_shell=true

func _on_Area2D_body_exited(_body):
	overlapping_shell=false

func hold_shell():
	if holding_shell==true:
		if looking_left==true:
			node_shell.position = node_mario.position + Vector2(-40,0);
		else:
			node_shell.position = node_mario.position + Vector2(38,0);
		if throwing_shell==true:
			holding_shell=false
			if looking_left==true:
				node_shell.velocity_throw=Vector2(-1,0)
			else:
				node_shell.velocity_throw=Vector2(1,0)
			node_shell.velocity_throw=node_shell.speed_throw * (node_shell.velocity_throw).normalized()
			throwing_shell=false


func _physics_process(_delta):
	get_input()
	velocity = move_and_slide(velocity,Vector2(0,-1),true)
	velocity.x = lerp(velocity.x,0,0.2)
	hold_shell()
	set_animation()
	$AnimatedSprite.offset=$AnimatedSprite.position

